"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadConfigFromRoot = exports.validateConfig = exports.getBabelCore = exports.logError = exports.getCacheDB = exports.getSha1 = exports.posixifyPath = exports.CLIError = void 0;
var os_1 = __importDefault(require("os"));
var fs_1 = __importDefault(require("fs"));
var lowdb_1 = __importDefault(require("lowdb"));
var path_1 = __importDefault(require("path"));
var crypto_1 = __importDefault(require("crypto"));
var make_dir_1 = __importDefault(require("make-dir"));
var debounce_1 = __importDefault(require("lodash/debounce"));
var resolve_from_1 = __importDefault(require("resolve-from"));
var FileAsync_1 = __importDefault(require("lowdb/adapters/FileAsync"));
var CLIError = /** @class */ (function (_super) {
    __extends(CLIError, _super);
    function CLIError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return CLIError;
}(Error));
exports.CLIError = CLIError;
function posixifyPath(filePath) {
    return filePath.split(path_1.default.sep).join(path_1.default.posix.sep);
}
exports.posixifyPath = posixifyPath;
function getSha1(contents) {
    var hash = crypto_1.default.createHash('sha1');
    hash.update(contents);
    return hash.digest('hex');
}
exports.getSha1 = getSha1;
function getCacheDB(projectPath, loadState) {
    return __awaiter(this, void 0, void 0, function () {
        var configPath, adapter, db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    configPath = path_1.default.join(os_1.default.homedir(), '.sb-babel-cli', "cache-timestamps-" + getSha1(projectPath));
                    return [4 /*yield*/, make_dir_1.default(path_1.default.dirname(configPath))];
                case 1:
                    _a.sent();
                    adapter = new FileAsync_1.default(configPath, {
                        serialize: JSON.stringify,
                    });
                    adapter.write = debounce_1.default(adapter.write, 1000);
                    return [4 /*yield*/, lowdb_1.default(adapter)];
                case 2:
                    db = _a.sent();
                    if (!loadState) {
                        db.setState({});
                    }
                    return [2 /*return*/, db];
            }
        });
    });
}
exports.getCacheDB = getCacheDB;
function logError(error) {
    if (error instanceof CLIError) {
        console.error('ERROR', error.message);
    }
    else {
        console.error(error);
    }
}
exports.logError = logError;
var babelCore;
function getBabelCore(projectPath) {
    if (babelCore == null) {
        var resolved = null;
        try {
            resolved = resolve_from_1.default(projectPath, '@babel/core');
        }
        catch (_) {
            /* No Op */
        }
        if (!resolved) {
            throw new CLIError('Unable to find @babel/core in your project');
        }
        // eslint-disable-next-line global-require,import/no-dynamic-require,@typescript-eslint/no-var-requires
        babelCore = require(resolved);
    }
    return babelCore;
}
exports.getBabelCore = getBabelCore;
var EXCLUDED_CONFIG_KEYS = ['rootDirectory', 'sourceDirectory', 'loadConfig', 'specifiedArgs'];
function validateConfig(config, sourceConfig) {
    var issues = [];
    if (typeof config !== 'object' || config == null || Array.isArray(config)) {
        issues.push('Config root is malformed');
    }
    else {
        var validKeys_1 = Object.keys(sourceConfig);
        EXCLUDED_CONFIG_KEYS.forEach(function (item) {
            validKeys_1.splice(validKeys_1.indexOf(item), 1);
        });
        var receivedKeys = Object.keys(config);
        var extraKeys = receivedKeys.filter(function (item) { return !validKeys_1.includes(item); });
        if (extraKeys.length > 0) {
            issues.push("Unknown config items: " + extraKeys.join(', '));
        }
        if (config.watch != null && typeof config.watch !== 'boolean') {
            issues.push('config.watch must be a valid boolean');
        }
        if (config.ignored != null && typeof config.ignored !== 'string') {
            issues.push('config.ignored must be a valid string');
        }
        if (config.ignoredForRestart != null && typeof config.ignoredForRestart !== 'string') {
            issues.push('config.ignoredForRestart must be a valid string');
        }
        if (config.sourceMaps != null && typeof config.sourceMaps !== 'boolean' && config.sourceMaps !== 'inline') {
            issues.push('config.sourceMaps must either be a boolean or "inline"');
        }
        if (config.resetCache != null && typeof config.resetCache !== 'boolean') {
            issues.push('config.resetCache must be a valid boolean');
        }
        if (config.keepExtraFiles != null && typeof config.keepExtraFiles !== 'boolean') {
            issues.push('config.keepExtraFiles must be a valid boolean');
        }
        if (config.execute != null && typeof config.execute !== 'string') {
            issues.push('config.execute must be a valid string');
        }
        if (config.executeDelay != null && typeof config.executeDelay !== 'number') {
            issues.push('config.executeDelay must be a valid number');
        }
        if (config.extensions != null &&
            (!Array.isArray(config.extensions) || !config.extensions.every(function (item) { return typeof item === 'string'; }))) {
            issues.push('config.extensions must be a valid array of strings');
        }
        if (config.printConfig != null && typeof config.printConfig !== 'boolean') {
            issues.push('config.printConfig must be a valid boolean');
        }
        if (config.nodeArgs != null &&
            (!Array.isArray(config.nodeArgs) || !config.nodeArgs.every(function (item) { return typeof item === 'string'; }))) {
            issues.push('config.nodeArgs must be a valid array of strings');
        }
        if (config.programArgs != null &&
            (!Array.isArray(config.programArgs) || !config.programArgs.every(function (item) { return typeof item === 'string'; }))) {
            issues.push('config.programArgs must be a valid array of strings');
        }
    }
    return issues;
}
exports.validateConfig = validateConfig;
function loadConfigFromRoot(rootDirectory, config) {
    return __awaiter(this, void 0, void 0, function () {
        var manifestPath, _1, parsed, _a, _b, _2, manifestConfig, issues, newConfig_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    manifestPath = path_1.default.join(rootDirectory, 'package.json');
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fs_1.default.promises.access(manifestPath, fs_1.default.constants.R_OK)];
                case 2:
                    _c.sent();
                    return [3 /*break*/, 4];
                case 3:
                    _1 = _c.sent();
                    // Manifest does not exist
                    return [2 /*return*/, config];
                case 4:
                    parsed = {};
                    _c.label = 5;
                case 5:
                    _c.trys.push([5, 7, , 8]);
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, fs_1.default.promises.readFile(manifestPath, 'utf8')];
                case 6:
                    parsed = _b.apply(_a, [_c.sent()]);
                    return [3 /*break*/, 8];
                case 7:
                    _2 = _c.sent();
                    // Manifest is not a valid JSON
                    console.warn("WARNING: Manifest file at " + manifestPath + " is malformed");
                    return [2 /*return*/, config];
                case 8:
                    if (typeof parsed !== 'object' || parsed == null) {
                        // Malformed manifest structure
                        return [2 /*return*/, config];
                    }
                    manifestConfig = parsed['sb-babel-cli'];
                    if (manifestConfig != null) {
                        issues = validateConfig(manifestConfig, config);
                        if (issues.length > 0) {
                            console.warn("WARNING: Malformed sb-babel-cli config in manifest at " + manifestPath);
                            console.log(issues.map(function (item) { return "  - " + item; }).join('\n'));
                            return [2 /*return*/, config];
                        }
                        newConfig_1 = __assign({}, manifestConfig);
                        config.specifiedArgs.concat(EXCLUDED_CONFIG_KEYS).forEach(function (key) {
                            newConfig_1[key] = config[key];
                        });
                        return [2 /*return*/, newConfig_1];
                    }
                    return [2 /*return*/, config];
            }
        });
    });
}
exports.loadConfigFromRoot = loadConfigFromRoot;
