"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var os_1 = __importDefault(require("os"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var chalk_1 = __importDefault(require("chalk"));
var make_dir_1 = __importDefault(require("make-dir"));
var chokidar_1 = __importDefault(require("chokidar"));
var anymatch_1 = __importDefault(require("anymatch"));
var debounce_1 = __importDefault(require("lodash/debounce"));
var child_process_1 = __importDefault(require("child_process"));
var sb_promise_queue_1 = require("sb-promise-queue");
var iterate_1 = __importDefault(require("./iterate"));
var helpers_1 = require("./helpers");
function main(cliConfig) {
    return __awaiter(this, void 0, void 0, function () {
        function log() {
            var items = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                items[_i] = arguments[_i];
            }
            if (config.execute) {
                console.log.apply(console, __spread(["" + chalk_1.default.yellow('[sb-babel-cli]')], items));
            }
            else {
                console.log.apply(console, __spread(items));
            }
        }
        function processFile(sourceFile, outputFile, stats) {
            return __awaiter(this, void 0, void 0, function () {
                var transformed, mapFile, outputContents;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!config.extensions.includes(path_1.default.extname(sourceFile)))
                                return [2 /*return*/];
                            return [4 /*yield*/, babelCore.transformFileAsync(sourceFile, {
                                    root: config.rootDirectory,
                                    sourceMaps: config.sourceMaps === 'inline' ? 'inline' : config.sourceMaps,
                                })];
                        case 1:
                            transformed = _a.sent();
                            if (transformed == null || transformed.code == null) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, make_dir_1.default(path_1.default.dirname(outputFile))];
                        case 2:
                            _a.sent();
                            mapFile = outputFile + ".map";
                            outputContents = transformed.code;
                            if (config.sourceMaps === true) {
                                outputContents += "\n\n//# sourceMappingURL=" + path_1.default.basename(mapFile);
                            }
                            return [4 /*yield*/, Promise.all([
                                    fs_1.default.promises.writeFile(outputFile, outputContents, {
                                        mode: stats.mode,
                                    }),
                                    // Write source maps if option is given.
                                    config.sourceMaps && config.sourceMaps !== 'inline'
                                        ? fs_1.default.promises.writeFile(mapFile, JSON.stringify(transformed.map, null, 2))
                                        : null,
                                ])];
                        case 3:
                            _a.sent();
                            log(sourceFile, '->', outputFile);
                            timestampCache.set(helpers_1.getSha1(sourceFile), stats.mtime.getTime()).write();
                            return [2 /*return*/];
                    }
                });
            });
        }
        function execute() {
            if (!config.execute) {
                return;
            }
            if (spawnedProcess == null) {
                log(chalk_1.default.yellow('to restart at any time, enter `rs`'));
            }
            log(chalk_1.default.green("starting 'node " + config.execute + "'"));
            if (spawnedProcess != null) {
                spawnedProcess.kill('SIGINT');
            }
            spawnedProcess = child_process_1.default.spawn(process.execPath, config.nodeArgs.concat([config.execute]).concat(config.programArgs), {
                stdio: 'inherit',
            });
        }
        var localConfig, config, spawnedProcess, timestampCache, babelCore, transformationQueue, getOutputFilePath, debounceExecute, watcher;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    localConfig = __assign({}, cliConfig);
                    localConfig.sourceDirectory = path_1.default.resolve(cliConfig.rootDirectory, cliConfig.sourceDirectory);
                    return [4 /*yield*/, helpers_1.loadConfigFromRoot(localConfig.rootDirectory, localConfig)];
                case 1:
                    config = _a.sent();
                    if (config.printConfig) {
                        console.log('CLI Config', JSON.stringify(config, null, 2));
                        console.log('Resolved Source Directory', localConfig.sourceDirectory);
                        console.log('Resolved Config (with config merged from Manifest)', JSON.stringify(config, null, 2));
                        process.exit(1);
                    }
                    if (!config.watch && config.execute) {
                        console.error('ERROR: --execute is not supported without --watch');
                        process.exit(1);
                    }
                    if (!config.outputDirectory) {
                        console.log('ERROR: You must specify output directory');
                        process.exit(1);
                    }
                    // Sort the longest extensions to the shortest. This will help with replace
                    config.extensions.sort(function (a, b) { return b.length - a.length; });
                    spawnedProcess = null;
                    return [4 /*yield*/, helpers_1.getCacheDB(config.sourceDirectory, !config.resetCache)];
                case 2:
                    timestampCache = _a.sent();
                    babelCore = helpers_1.getBabelCore(config.sourceDirectory);
                    transformationQueue = new sb_promise_queue_1.PromiseQueue({ concurrency: os_1.default.cpus().length });
                    getOutputFilePath = function (filePath) {
                        var foundExt = config.extensions.find(function (ext) { return filePath.endsWith(ext); });
                        if (foundExt != null) {
                            return filePath.slice(0, -1 * foundExt.length) + ".js";
                        }
                        return filePath;
                    };
                    debounceExecute = debounce_1.default(function () {
                        try {
                            execute();
                        }
                        catch (error) {
                            helpers_1.logError(error);
                        }
                    }, config.executeDelay);
                    return [4 /*yield*/, iterate_1.default({
                            config: config,
                            getOutputFilePath: getOutputFilePath,
                            callback: function (sourceFile, outputFile, stats) {
                                return __awaiter(this, void 0, void 0, function () {
                                    var cachedTimestamp;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, timestampCache.get(helpers_1.getSha1(sourceFile)).value()];
                                            case 1:
                                                cachedTimestamp = _a.sent();
                                                if (cachedTimestamp === stats.mtime.getTime()) {
                                                    if (!config.execute) {
                                                        log(sourceFile, 'is unchanged');
                                                    }
                                                    return [2 /*return*/];
                                                }
                                                transformationQueue.add(function () { return processFile(sourceFile, outputFile, stats); }).catch(helpers_1.logError);
                                                return [2 /*return*/];
                                        }
                                    });
                                });
                            },
                        })];
                case 3:
                    _a.sent();
                    if (!!config.watch) return [3 /*break*/, 5];
                    return [4 /*yield*/, transformationQueue.waitTillIdle()];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
                case 5:
                    if (config.execute && process.stdin) {
                        if (typeof process.stdin.unref === 'function') {
                            process.stdin.unref();
                        }
                        process.stdin.on('data', function (chunk) {
                            if (chunk.toString().trim() === 'rs') {
                                debounceExecute();
                            }
                        });
                    }
                    watcher = chokidar_1.default.watch(config.sourceDirectory, {
                        ignored: config.ignored,
                        alwaysStat: true,
                        ignoreInitial: true,
                    });
                    watcher.on('add', function (givenFileName, stats) {
                        var fileName = path_1.default.relative(config.sourceDirectory, givenFileName);
                        var sourceFile = path_1.default.join(config.sourceDirectory, fileName);
                        var outputFile = path_1.default.join(config.outputDirectory, fileName);
                        transformationQueue
                            .add(function () { return processFile(sourceFile, getOutputFilePath(outputFile), stats); })
                            .catch(helpers_1.logError)
                            .then(function () {
                            if (!config.ignoredForRestart || !anymatch_1.default(config.ignoredForRestart, helpers_1.posixifyPath(sourceFile))) {
                                debounceExecute();
                            }
                        });
                    });
                    watcher.on('change', function (givenFileName, stats) {
                        var fileName = path_1.default.relative(config.sourceDirectory, givenFileName);
                        var sourceFile = path_1.default.join(config.sourceDirectory, fileName);
                        var outputFile = path_1.default.join(config.outputDirectory, fileName);
                        transformationQueue
                            .add(function () { return processFile(sourceFile, getOutputFilePath(outputFile), stats); })
                            .catch(helpers_1.logError)
                            .then(function () {
                            if (!config.ignoredForRestart || !anymatch_1.default(config.ignoredForRestart, helpers_1.posixifyPath(sourceFile))) {
                                debounceExecute();
                            }
                        });
                    });
                    watcher.on('unlink', function (givenFileName) {
                        var fileName = path_1.default.relative(config.sourceDirectory, givenFileName);
                        var outputFile = path_1.default.join(config.outputDirectory, fileName);
                        fs_1.default.promises.unlink(outputFile).catch(function () {
                            /* No Op */
                        });
                    });
                    return [4 /*yield*/, transformationQueue.waitTillIdle()];
                case 6:
                    _a.sent();
                    debounceExecute();
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = main;
