"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var del_1 = __importDefault(require("del"));
var path_1 = __importDefault(require("path"));
var p_map_1 = __importDefault(require("p-map"));
var make_dir_1 = __importDefault(require("make-dir"));
var anymatch_1 = __importDefault(require("anymatch"));
var helpers_1 = require("./helpers");
function iterate(_a) {
    var config = _a.config, callback = _a.callback, getOutputFilePath = _a.getOutputFilePath;
    return __awaiter(this, void 0, void 0, function () {
        var contents, outputStats, outputDirectoryExists, _1, outputContents, _b, whitelist_1, filesToDelete;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, fs_1.default.promises.readdir(config.sourceDirectory)];
                case 1:
                    contents = _c.sent();
                    outputStats = null;
                    outputDirectoryExists = false;
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, fs_1.default.promises.stat(config.outputDirectory)];
                case 3:
                    outputStats = _c.sent();
                    return [3 /*break*/, 5];
                case 4:
                    _1 = _c.sent();
                    return [3 /*break*/, 5];
                case 5:
                    if (!outputStats) return [3 /*break*/, 8];
                    if (!outputStats.isDirectory()) return [3 /*break*/, 6];
                    outputDirectoryExists = true;
                    return [3 /*break*/, 8];
                case 6: return [4 /*yield*/, del_1.default(config.outputDirectory)];
                case 7:
                    _c.sent();
                    outputStats = null;
                    _c.label = 8;
                case 8:
                    if (!outputStats) return [3 /*break*/, 10];
                    return [4 /*yield*/, fs_1.default.promises.readdir(config.outputDirectory)];
                case 9:
                    _b = _c.sent();
                    return [3 /*break*/, 11];
                case 10:
                    _b = [];
                    _c.label = 11;
                case 11:
                    outputContents = _b;
                    if (!!config.keepExtraFiles) return [3 /*break*/, 13];
                    whitelist_1 = contents.map(getOutputFilePath);
                    if (config.sourceMaps === true) {
                        whitelist_1 = whitelist_1.concat(whitelist_1.map(function (item) { return item + ".map"; }));
                    }
                    filesToDelete = outputContents
                        .filter(function (item) { return !whitelist_1.includes(item); })
                        .map(function (item) { return path_1.default.resolve(config.outputDirectory, item); });
                    return [4 /*yield*/, Promise.all(filesToDelete.map(function (item) { return del_1.default(item); }))];
                case 12:
                    _c.sent();
                    _c.label = 13;
                case 13: return [4 /*yield*/, p_map_1.default(contents, function (itemName) {
                        return __awaiter(this, void 0, void 0, function () {
                            var filePath, stat, foundExt, outputFile;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        filePath = path_1.default.join(config.sourceDirectory, itemName);
                                        return [4 /*yield*/, fs_1.default.promises.lstat(filePath)];
                                    case 1:
                                        stat = _a.sent();
                                        if (stat.isSymbolicLink()) {
                                            // NOTE: We ignore symlinks
                                            return [2 /*return*/];
                                        }
                                        if (config.ignored &&
                                            (anymatch_1.default(config.ignored, itemName) ||
                                                anymatch_1.default(config.ignored, helpers_1.posixifyPath(filePath)) ||
                                                anymatch_1.default(config.ignored, helpers_1.posixifyPath(path_1.default.relative(config.rootDirectory, filePath))))
                                        // TODO: Convert above to posix
                                        ) {
                                            // NOTE: We ignore ignored files
                                            return [2 /*return*/];
                                        }
                                        if (!stat.isFile()) return [3 /*break*/, 5];
                                        foundExt = config.extensions.find(function (ext) { return itemName.endsWith(ext); });
                                        if (!foundExt) {
                                            return [2 /*return*/];
                                        }
                                        if (!!outputDirectoryExists) return [3 /*break*/, 3];
                                        return [4 /*yield*/, make_dir_1.default(config.outputDirectory)];
                                    case 2:
                                        _a.sent();
                                        outputDirectoryExists = true;
                                        _a.label = 3;
                                    case 3:
                                        outputFile = getOutputFilePath(path_1.default.join(config.outputDirectory, itemName));
                                        return [4 /*yield*/, callback(filePath, outputFile, stat)];
                                    case 4:
                                        _a.sent();
                                        return [3 /*break*/, 7];
                                    case 5:
                                        if (!stat.isDirectory()) return [3 /*break*/, 7];
                                        return [4 /*yield*/, iterate({
                                                config: __assign(__assign({}, config), { sourceDirectory: path_1.default.join(config.sourceDirectory, itemName) }),
                                                getOutputFilePath: getOutputFilePath,
                                                callback: callback,
                                            })];
                                    case 6:
                                        _a.sent();
                                        _a.label = 7;
                                    case 7: return [2 /*return*/];
                                }
                            });
                        });
                    })];
                case 14:
                    _c.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = iterate;
